﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Worm extends Sprite
	{
		private var position_array:Array;
		private var curver:Array;
		private var canevas:Sprite;
		private var canevas2:Sprite;
		private var angle:Number;
		private var angleBis:Number;
		private var vitesse:Number=10;
		private var a:Number;
		private var pas:Number = 2;
		private var rot:Number=0;
		public function Worm()
		{
			addEventListener(Event.ADDED_TO_STAGE,added_handler);
		}
		private function added_handler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN, down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP, up_handler);
		}
		private function down_handler(e:MouseEvent):void
		{
			position_array = new Array();
			curver = new Array();
			angle = 0;
			angleBis=0;
			a=1;
			pas=2;
			position_array.push(new Array(e.stageX,e.stageY));
			stage.addEventListener(MouseEvent.MOUSE_MOVE, move_handler);
		}
		private function move_handler(e:MouseEvent):void
		{
			position_array.push(new Array(e.stageX,e.stageY));
		}
		private function up_handler(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE,move_handler);
			build_circles();
		}
		private function build_circles():void
		{
			for(var i:Number=0;i<position_array.length;i+=pas){
				if(i+pas < position_array.length){
					var posx:Number = position_array[i+pas][0]-position_array[i][0];
					var posy:Number = position_array[i+pas][1]-position_array[i][1];
					var ray:Number = Math.sqrt(Math.pow(posx,2) + Math.pow(posy,2));
					var newx:Number = position_array[i][0]/2 + position_array[i+pas][0]/2;
					var newy:Number = position_array[i][1]/2 + position_array[i+pas][1]/2;
					curver.push(new Array(newx,newy,ray/2));
				}
			}
			stage.addEventListener(Event.ENTER_FRAME,enterFrame);
		}
		private function enterFrame(e:Event):void
		{
			
			if(curver.length>0){
				
				if(angle==0){
					var X:Number = curver[0][0] - position_array[(pas-2)][0];
					var Y:Number = curver[0][1] - position_array[(pas-2)][1];
					if(X>=0){
						angle = Math.atan(Y/X)*180/Math.PI - 180;
						angleBis = Math.atan(Y/X)*180/Math.PI + 180*(a-1);
					}else{
						angle = Math.atan(Y/X)*180/Math.PI;
						angleBis = Math.atan(Y/X)*180/Math.PI + a*180;
					}
				}
				if(angle*a>=angleBis*a){
					curver.shift();
					a*=-1;
					angle=0;
					pas+=2;
				}else{
					
					var posx:Number = Math.cos(angle*Math.PI/180)*curver[0][2]+curver[0][0];
					var posy:Number = Math.sin(angle*Math.PI/180)*curver[0][2]+curver[0][1];
					
					rot += 10;
					angle+=vitesse*a;
					///////////////////////////////////ajout de la class Rotater (si dessous) ;
					var drop:Rotater = new Rotater();
					drop.x = posx;
					drop.y = posy;
					drop.rotation = rot ;
					addChild(drop);
					
					///////////////////////////////////ajout du movie clip (crée dans la bibliotèque du fla, lié par la class Symbole1() ) ;
					var dropMc:Symbole1 = new Symbole1();
					dropMc.x = posx;
					dropMc.y = posy;
					dropMc.rotation = rot ;
					addChild(dropMc);
					
				}
				
			}else{
				stage.removeEventListener(Event.ENTER_FRAME,enterFrame);
				
			}
			
		}
	}
}

//////////////////////////////////creation de la forme (le rond orange);
import flash.display.Sprite;
class Forme extends Sprite{

	var n: Number = (50);
	var m: Number =  ( 50);
	
	function Forme(){

		graphics.lineStyle(.2,0xff9900,1);
		graphics.drawCircle(0,0,60);
	}
}

//////////////////////////////////creation de la deformation de ce rond (pour donner un ovale) + de la rotation continue;
import flash.display.Sprite;
import flash.events.Event;
import flash.geom.ColorTransform;

class Rotater extends Sprite{

	/////////////////////////////on ajoute la class Forme, donc ajout du rond orange;
	var drop:Forme = new Forme();
	var rotat:Number=0;
	var m1:Number = 10;
	var m2:Number = 1;
	
	function Rotater(){

		drop.scaleX=1.1;
		addChild(drop);
		addEventListener(Event.ENTER_FRAME,enterFrame)
		
	}
	
	private function enterFrame(e:Event):void{
		
		if (m1 % 30 == 0) {m2*= -1;}
		m1 += m2;
		
		rotat += 3;
		drop.rotation = rotat;
		drop.x = m1 - 15;

	}

}